/*
 *        spAudio_Null.c
 */

#include <sp/spDefs.h>
#include <sp/spBase.h>
#include <sp/spMemory.h>
#include <sp/spFile.h>

#include <sp/spAudioP.h>

#if !defined(SP_SUPPORT_AUDIO)

int spGetNumAudioDriverArch(void)
{
    return 0;
}

const char *spGetAudioDriverNameArch(int index)
{
    return NULL;
}

spBool spInitAudioDriverArch(spAudio audio, const char *driver_name, void *data)
{
    return SP_FALSE;
}

spBool spGetNumAudioDeviceArch(spAudio audio, int *num_device)
{
    return SP_FALSE;
}

const char *spGetAudioDeviceNameArch(spAudio audio, int device_index)
{
    if (device_index == 0) {
        return "Default";
    }
    return NULL;
}

spBool spSelectAudioDeviceArch(spAudio audio, int device_index)
{
    return SP_FALSE;
}

spBool spSetAudioSampleBitArch(spAudio audio)
{
    return SP_TRUE;
}

spBool spSetAudioSampleRateArch(spAudio audio)
{
    return SP_TRUE;
}

spBool spSetAudioChannelArch(spAudio audio)
{
    return SP_TRUE;
}

spBool spSetAudioBufferSizeArch(spAudio audio)
{
    return SP_TRUE;
}

spBool spSetAudioNumBufferArch(spAudio audio)
{
    return SP_TRUE;
}

spBool spSetAudioBlockingModeArch(spAudio audio)
{
    return SP_TRUE;
}

spAudioCallbackType spSetAudioCallbackFuncArch(spAudio audio)
{
    return 0;
}

spBool spOpenInputAudioDeviceArch(spAudio audio)
{
    return SP_FALSE;
}

spBool spOpenOutputAudioDeviceArch(spAudio audio)
{
    return SP_FALSE;
}

spBool spCloseAudioDeviceArch(spAudio audio)
{
    return SP_TRUE;
}

long spReadAudioArch(spAudio audio, char *data, long length)
{
    return length;
}

long spWriteAudioArch(spAudio audio, char *data, long length)
{
    return length;
}

spBool spGetAudioOutputPositionArch(spAudio audio, spLong *position)
{
    return SP_TRUE;
}

spBool spStopAudioArch(spAudio audio)
{
    return SP_TRUE;
}

spBool spSyncAudioArch(spAudio audio)
{
    return SP_TRUE;
}

spBool spFreeAudioDriverArch(spAudio audio)
{
    return SP_TRUE;
}

void spTerminateAudioArch(void)
{
    return;
}
#endif
