/*
 *        spRwPlugin.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sp/spBase.h>
#include <sp/spMemory.h>
#include <sp/spWave.h>

#include <sp/spOutputPluginP.h>
#include <sp/spInputPluginP.h>
#include <sp/spRwPluginP.h>

spBool spIsRwPlugin(spPlugin *plugin)
{
    if (plugin == NULL) return SP_FALSE;

    if (spEqPluginType(plugin, SP_PLUGIN_RW) == SP_TRUE) {
        return SP_TRUE;
    }
    
    return SP_FALSE;
}

spBool spIsAudioDriverPlugin(spPlugin *plugin)
{
    if (plugin == NULL) return SP_FALSE;

    if (spEqPluginType(plugin, SP_PLUGIN_RW) == SP_TRUE
        && spGetPluginDeviceType(plugin) == SP_PLUGIN_DEVICE_AUDIO) {
        spDebug(80, "spIsAudioDriverPlugin", "SP_TRUE\n");
        return SP_TRUE;
    }
    
    return SP_FALSE;
}

spBool spIsSupportedByPluginForWrite(spPlugin *plugin, const char *filename)
{
    spIoPluginRec *rec;

    if (spIsIoPlugin(plugin) == SP_FALSE || filename == NULL) return SP_FALSE;

    rec = (spIoPluginRec *)plugin->rec;
    
    if (rec->is_supported == NULL) return SP_FALSE;

    return rec->is_supported(spGetSuffix(filename));
}
